<?php

class ControllerExtensionPaymentPrimepayments2 extends Controller {
	private $error = array();

	public function index() {
		$this->load->language( 'extension/payment/primepayments2' );

		$this->document->setTitle( $this->language->get( 'heading_title' ) );

		$this->load->model( 'setting/setting' );

		if ( ( $this->request->server['REQUEST_METHOD'] == 'POST' ) && $this->validate() ) {
			$this->model_setting_setting->editSetting( 'payment_primepayments2', $this->request->post );

			$this->session->data['success'] = $this->language->get( 'text_success' );

			$this->response->redirect( $this->url->link( 'marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true ) );
		}

		if ( isset( $this->error['warning'] ) ) {
			$data['error_warning'] = $this->error['warning'];
		}
		else {
			$data['error_warning'] = '';
		}

		if ( isset( $this->error['merchant'] ) ) {
			$data['error_merchant'] = $this->error['merchant'];
		}
		else {
			$data['error_merchant'] = '';
		}

		if ( isset( $this->error['signature'] ) ) {
			$data['error_signature'] = $this->error['signature'];
		}
		else {
			$data['error_signature'] = '';
		}

		if ( isset( $this->error['type'] ) ) {
			$data['error_type'] = $this->error['type'];
		}
		else {
			$data['error_type'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'text_home' ),
			'href' => $this->url->link( 'common/dashboard', 'user_token=' . $this->session->data['user_token'], true )
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'text_extension' ),
			'href' => $this->url->link( 'marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true )
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'heading_title' ),
			'href' => $this->url->link( 'extension/payment/primepayments2', 'user_token=' . $this->session->data['user_token'], true )
		);

		$data['action'] = $this->url->link( 'extension/payment/primepayments2', 'user_token=' . $this->session->data['user_token'], true );

		$data['cancel'] = $this->url->link( 'marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true );


		// =======================================================================
		// Merchant ID
		// =======================================================================
		$merchant_key = 'payment_primepayments2_merchant';
		if ( isset( $this->request->post[ $merchant_key ] ) ) {
			$data[ $merchant_key ] = $this->request->post[ $merchant_key ];
		}
		else {
			$data[ $merchant_key ] = $this->config->get( $merchant_key );
		}

		// =======================================================================
		// Secret key 1
		// =======================================================================
		$secret_1_key = 'payment_primepayments2_secret_1';
		if ( isset( $this->request->post[ $secret_1_key ] ) ) {
			$data[ $secret_1_key ] = $this->request->post[ $secret_1_key ];
		}
		else {
			$data[ $secret_1_key ] = $this->config->get( $secret_1_key );
		}

		// =======================================================================
		// Secret key 2
		// =======================================================================
		$secret_2_key = 'payment_primepayments2_secret_2';
		if ( isset( $this->request->post[ $secret_2_key ] ) ) {
			$data[ $secret_2_key ] = $this->request->post[ $secret_2_key ];
		}
		else {
			$data[ $secret_2_key ] = $this->config->get( $secret_2_key );
		}

		// =======================================================================
		// Payments type
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments2_type'] ) ) {
			$data['payment_primepayments2_type'] = $this->request->post['payment_primepayments2_type'];
		}
		else {
			$data['payment_primepayments2_type'] = $this->config->get( 'payment_primepayments2_type' );
		}

		// =======================================================================
		// Order status
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments2_order_status_id'] ) ) {
			$data['payment_primepayments2_order_status_id'] = $this->request->post['payment_primepayments2_order_status_id'];
		}
		else {
			$data['payment_primepayments2_order_status_id'] = $this->config->get( 'payment_primepayments2_order_status_id' );
		}

		// =======================================================================
		// Gateway name
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments2_gateway_name'] ) ) {
			$data['payment_primepayments2_gateway_name'] = $this->request->post['payment_primepayments2_gateway_name'];
		}
		else {
			$data['payment_primepayments2_gateway_name'] = $this->config->get( 'payment_primepayments2_gateway_name' );
		}

		$data['site_url'] = HTTPS_CATALOG;

		$this->load->model( 'localisation/order_status' );

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		// =======================================================================
		// GEO zones
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments2_geo_zone_id'] ) ) {
			$data['payment_primepayments2_geo_zone_id'] = $this->request->post['payment_primepayments2_geo_zone_id'];
		}
		else {
			$data['payment_primepayments2_geo_zone_id'] = $this->config->get( 'payment_primepayments2_geo_zone_id' );
		}

		$this->load->model( 'localisation/geo_zone' );

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if ( isset( $this->request->post['payment_primepayments2_status'] ) ) {
			$data['payment_primepayments2_status'] = $this->request->post['payment_primepayments2_status'];
		}
		else {
			$data['payment_primepayments2_status'] = $this->config->get( 'payment_primepayments2_status' );
		}

		$data['header'] = $this->load->controller( 'common/header' );
		$data['column_left'] = $this->load->controller( 'common/column_left' );
		$data['footer'] = $this->load->controller( 'common/footer' );


		// Get balance
		$data['balance'] = $this->get_project_balance();

		$this->response->setOutput( $this->load->view( 'extension/payment/primepayments2', $data ) );
	}

	protected function validate() {
		if ( ! $this->user->hasPermission( 'modify', 'extension/payment/primepayments2' ) ) {
			$this->error['warning'] = $this->language->get( 'error_permission' );
		}

		if ( ! $this->request->post['payment_primepayments2_merchant'] ) {
			$this->error['merchant'] = $this->language->get( 'error_merchant' );
		}

		if ( ! $this->request->post['payment_primepayments2_secret_1'] ) {
			$this->error['error_secret_1'] = $this->language->get( 'error_secret_1_message' );
		}

		if ( ! $this->request->post['payment_primepayments2_secret_2'] ) {
			$this->error['error_secret_2'] = $this->language->get( 'error_secret_2_message' );
		}

		return ! $this->error;
	}
	/**
	 * Get current project balance
	 * @since v2.0
	 * @author @cosmocoder
	*/
	protected function get_project_balance(){
		$secret_key_1 = $this->config->get( 'payment_primepayments2_secret_1' );
		$project_id   = $this->config->get( 'payment_primepayments2_merchant' );
		$action		  = 'getProjectBalance';

		if( ! $secret_key_1 || ! $project_id ) return null;

		$args = array(
			'action'	=> $action,
			'project'	=> $project_id,
			'sign'		=> md5($secret_key_1 . $action . $project_id),
		);

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://pay.primepayments.ru/API/v1/' );
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($args));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$server_output = curl_exec($ch);
		curl_close ($ch);

		$answer = json_decode($server_output, true);
		if( $answer['status'] === 'OK' ){
			return $answer['result'];
		}

		return null;
	}
}