<?php

class ControllerExtensionPaymentPrimepayments2 extends Controller {
	public function index() {
		if (
			isset( $this->request->request ) &&
			isset( $this->request->request['route'] ) &&
			$this->request->request['route'] == 'checkout/success'
		) {
			return;
		}

		$data['button_confirm'] = $this->language->get( 'button_confirm' );
		$this->load->model( 'localisation/currency' );

		$this->load->language( 'extension/payment/primepayments2' );
		$payment_types 	= $this->config->get( 'payment_primepayments2_type' );

		return $this->load->view( 'extension/payment/primepayments2', array(
			'action'			=> HTTPS_SERVER . '/index.php?route=extension/payment/primepayments2/create_payment_link',
			'payment_type'		=> $payment_types,
			'title_payway_method'	=> $this->language->get( 'title_payway_method' ),
		) );
	}

	public function callback() {
		//=========================================================
		// Handle PAYED callback webhook from PrimePayments2
		//=========================================================
		$secret_2 = $this->config->get( 'payment_primepayments2_secret_2' );

		if( $_REQUEST['action'] === 'order_payed' ) {
			// Validate sign
			$sign = md5( $secret_2 . $_REQUEST['orderID'] . $_REQUEST['payWay'] . $_REQUEST['innerID'] . $_REQUEST['sum'] . $_REQUEST['webmaster_profit'] );

			//TODO: Handle unsigned requests
			if ( $sign !== $_REQUEST['sign'] ) {
				echo 'Incorrect signature! Check the secret words in the settings.';
				exit;
			};

			//$this->log->write( 'Incomed request' );
			if ( $this->request->post['action'] === 'order_payed' ) {
				$this->load->model( 'checkout/order' );
				$this->model_checkout_order->addOrderHistory( $_REQUEST['innerID'], $this->config->get( 'payment_primepayments2_order_status_id' ) );

				echo 'OK';
				exit;
			}
		}

		else if( $_REQUEST['action'] === 'order_cancel' ){
			$sign = md5( $secret_2 . $_REQUEST['orderID'] . $_REQUEST['innerID'] );

			if( $sign !== $_REQUEST['sign'] ){
				echo 'Incorrect signature! Check the secret words in the settings.';
				exit;
			};

			//На наш запрос сайт должен ответить "OK" (англ. символы, без кавычек)
			echo 'OK';
		}
	}

	public function create_payment_link(){
		$this->load->model( 'checkout/order' );
		$this->load->model( 'localisation/currency' );

		$this->load->language( 'extension/payment/primepayments2' );


		$order_info = $this->model_checkout_order->getOrder( $this->session->data['order_id'] );

		$allowed_currencies = array('USD', 'RUB', 'EUR');

		$order_id	= $this->session->data['order_id'];
		$price 		= $order_info['total'];
		$currency 	= $order_info['currency_code'];

		if( ! in_array( $currency, $allowed_currencies ) ){
			$result = array(
				'status'	=> 'BAD',
				'message'	=> $this->language->get('currency_error'),
			);

			echo json_encode( $result );
		}


		$project_id 	= $this->config->get( 'payment_primepayments2_merchant' );
		$secret_1 		= $this->config->get( 'payment_primepayments2_secret_1' );

		$payway = (int) $_POST['payWay'];

		$args = array(
			'action' 			=> 'initPayment',
			'project'			=> $project_id,
			'sum'				=> $price,
			'currency'			=> $currency,
			'email'				=> $order_info['email'],
			'payWay'			=> $payway,
			'innerID'			=> $order_id,
			'returnLink'		=> 1,
			'needFailNotice'	=> 1,
			'lang'				=> strtoupper( $this->language->get('code') ),
			'sign'				=> md5( $secret_1 . 'initPayment' . $project_id . $price . $currency . $order_id . $order_info['email'] . $payway),
		);

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://pay.primepayments.ru/API/v1/' );
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($args));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$server_output = curl_exec($ch);
		curl_close ($ch);

		$answer = json_decode($server_output, true);

		if (isset($answer['status']) && $answer['status'] == 'OK') {
			echo json_encode( array(
				'redirect'	=> $answer['result'],
				'status'	=> 'OK'
			) );

		} else {
			echo json_encode(array(
				'status'	=> 'BAD',
				'message'	=> $answer['result'],
			));
		}
	}
}
